// module msgsocket.d
// Copyright Dr.E.Huckert 02-2018
// This class defines the package structur for hu_ftp2

// V1.X27

module msgsocket;

import d_trace;

class MSGSOCKET
{
private:
  char     operation;    
  ubyte [] content;   // ohne Operationszeichen!
public:
  this(char op, ubyte[] cont, uint lcont)
  {
    this.operation = op;
    this.content   = cont[0 .. lcont];
  };
  this(char op, ubyte[] cont)
  {
    this.operation = op;
    this.content   = cont;
  };
  this(char op, string cont)
  {
    this.operation = op;
    this.content   = cast(ubyte [])cont;
  };
  ~this()
  {
  };
  char get_operation()
  { 
    return this.operation; 
  };
  void set_operation(char op)
  { 
    this.operation = op; 
  };
  // Liefert Inhalt ohne Operationszeichen!
  ubyte [] get_content()
  {
    return this.content;
  }
  // Liefert die Laenge des Inhalts ohne Operationszeichen!
  long get_content_length()
  {
    return content.length;
  };
  // Liefert die Laenge des Inhalts inkl. Operationszeichen!
  long get_message_length()
  {
    return content.length + char.sizeof;
  };
  void set_content(ubyte [] con)
  {
    this.content = con;
  };
  void set_content_length(uint len)
  {
    this.content.length = len;
  };
  int parse_and_fill(char *src, long lsrc)
  {
    int ret = 0;
    return ret;
  };
  //
  ubyte [] flatten()
  {
    ubyte[] ps = new ubyte[content.length];
    ps = cast(ubyte[])this.content;
    return ps;
  };
  int  get_field(char *src, int fieldno, char *dest, int ldest, 
                  char sep)
  {
    int ret = 0;
    return ret;
  };
};
